<script setup lang="ts">
import { computed, nextTick, onMounted } from 'vue'
import { ref } from 'vue'
import type { VForm } from 'vuetify/components'
import { type Member } from '@/types/Member'

const initialMember: Member = {
  id: -1,
  name: '',
  tel: ''
}
const search = ref('')
const filteredMember = computed(() => {
  return members.value.filter((members) => members.name.includes(search.value))
})

const editedMember = ref<Member>(JSON.parse(JSON.stringify(initialMember)))
const members = ref<Member[]>([])
let editedIndex = -1
let lastId = 6
const itemsPerPage = ref<any>(5)
const page = ref(1)
const pageCount = computed(() => {
  return Math.ceil(members.value.length / itemsPerPage.value)
})
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Tel',
    key: 'tel',
    value: 'tel'
  },

  { title: '', key: 'actions', sortable: false }
]
function initialize() {
  members.value = [
    {
      id: 1,
      name: 'manager',
      tel: '0987654321'
    },
    {
      id: 2,
      name: 'kanoknapas',
      tel: '0987653466'
    },
    {
      id: 3,
      name: 'staff',
      tel: '0987634876'
    },
    {
      id: 4,
      name: 'top',
      tel: '0987947455'
    },
    {
      id: 5,
      name: 'staff3',
      tel: '0987653466'
    }
  ]
}
onMounted(() => {
  initialize()
})

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedMember.value = Object.assign({}, initialMember)
    editedIndex = -1
  })
}

async function save() {
  const { valid } = await refForm.value!.validate()

  if (!valid) return
  if (editedIndex > -1) {
    Object.assign(members.value[editedIndex], editedMember.value)
  } else {
    editedMember.value.id = lastId++
    members.value.push(editedMember.value)
  }
  closeDialog()
}

function onSubmit() {}

function editItem(item: Member) {
  editedIndex = members.value.indexOf(item)
  editedMember.value = Object.assign({}, item)
  dialog.value = true
}

function deleteItem(item: Member) {
  editedIndex = members.value.indexOf(item)
  editedMember.value = Object.assign({}, item)
  dialogDelete.value = true
}

function deleteItemConfirm() {
  members.value.splice(editedIndex, 1)
  closeDelete()
  editedIndex = -1
}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedMember.value = Object.assign({}, initialMember)
  })
}
</script>

<template>
  <div style="width: 95%; height: 100%">
    <br />
    <v-card-title class="d-flex align-center pe-2">
      <v-spacer></v-spacer>
    </v-card-title>
    <v-data-table
      v-model:page="page"
      :headers="headers"
      :items="filteredMember"
      :items-per-page="itemsPerPage"
    >
      <template v-slot:top>
        <v-toolbar flat color="#F48FB1">
          <v-toolbar-title>
            <v-icon icon="mdi-account"></v-icon>
            Member</v-toolbar-title
          >
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn style="background-color: #eceff1" v-bind="props" variant="flat">
                <v-icon icon="mdi-plus" size="large"></v-icon>
                New Member
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">New Member</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="6">
                        <v-text-field
                          v-model="editedMember.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="12">
                        <v-text-field
                          v-model="editedMember.tel"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required', (v) => !/[^0-9]/g.test(v)]"
                          clearable
                          label="Tel"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                  <br />
                </v-form>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="red" variant="flat" @click="closeDialog()"> Close </v-btn>
                <v-btn color="green" variant="flat" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <br />
              <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title
              ><br />
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="red" variant="flat" width="80px" @click="closeDelete">Cancel</v-btn>
                <v-btn color="green" variant="flat" width="80px" @click="deleteItemConfirm"
                  >OK</v-btn
                >
                <v-spacer></v-spacer>
              </v-card-actions>
              <br />
            </v-card>
          </v-dialog>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-text-field
            v-model="search"
            prepend-inner-icon="mdi-magnify"
            density="compact"
            label="Search"
            single-line
            flat
            hide-details
            variant="outlined"
            style="margin-right: 20px"
          >
          </v-text-field>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
        <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="initialize"> Reset </v-btn>
      </template>
      <template v-slot:bottom>
        <div class="text-center pt-2">
          <v-pagination v-model="page" :length="pageCount"></v-pagination>
        </div>
      </template>
    </v-data-table>
  </div>
</template>
